SystemOrganization addCategory: #ConfigurationOfEduTech!

Object subclass: #ConfigurationOfEduTech
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfEduTech'!

!ConfigurationOfEduTech class methodsFor: 'development support' stamp: 'JochenRick 10/18/2013 10:37'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfEduTech class methodsFor: 'private' stamp: 'JochenRick 10/18/2013 10:37'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfEduTech class methodsFor: 'private' stamp: 'JochenRick 10/18/2013 10:37'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfEduTech class methodsFor: 'private' stamp: 'JochenRick 10/18/2013 10:37'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfEduTech class methodsFor: 'metacello tool support' stamp: 'JochenRick 10/18/2013 10:37'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfEduTech class methodsFor: 'loading' stamp: 'JochenRick 10/18/2013 10:37'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfEduTech class methodsFor: 'loading' stamp: 'JochenRick 10/18/2013 10:37'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfEduTech class methodsFor: 'loading' stamp: 'JochenRick 10/18/2013 10:37'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfEduTech class methodsFor: 'accessing' stamp: 'JochenRick 10/18/2013 10:37'!
project

	^self new project! !

!ConfigurationOfEduTech class methodsFor: 'development support' stamp: 'JochenRick 10/18/2013 10:37'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfEduTech methodsFor: 'baselines' stamp: 'JochenRick 10/18/2013 11:00'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec
				blessing: #baseline;
				description: 'First Public Version';
				author: 'JochenRick';
				timestamp: '18/10/2013';
				repository: 'http://www.smalltalkhub.com/mc/JochenRick/EduTech/main'.
			"Require the XMLParser for communicating with the MicroWorld Server."
			spec project: 'XMLParser'
				with: [ spec 
					className: 'ConfigurationOfXMLParser';
					versionString: #stable;
					repository: 'http://ss3.gemtalksystems.com/ss/MetaRepoForPharo20'].
			spec package: 'EduTech' with: [ spec requires: 'XMLParser' ].
			].
! !

!ConfigurationOfEduTech methodsFor: 'accessing' stamp: 'JochenRick 10/18/2013 10:37'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfEduTech methodsFor: 'symbolic versions' stamp: 'JochenRick 10/18/2013 10:49'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.! !

!ConfigurationOfEduTech methodsFor: 'accessing' stamp: 'JochenRick 10/18/2013 10:37'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfEduTech methodsFor: 'symbolic versions' stamp: 'JochenRick 10/18/2013 10:49'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.! !

!ConfigurationOfEduTech methodsFor: 'versions' stamp: 'JochenRick 10/18/2013 14:26'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec package: 'EduTech' with: 'EduTech-JochenRick.6'
		]! !
